<?php
/**
 * @filename TokenFactory.php
 * @author Jerry Yan <792602257@qq.com>
 * @date 2020/12/17 14:48
 */


namespace JerryYan\DSL\Token;


class TokenFactory
{
    /** @var array<string, string> Token类型及映射类 */
    private $tokenMap = [
        Token::AND => TokenAnd::class,
        Token::OR => TokenOr::class,
        Token::VAR => TokenVar::class,
    ];

    protected $tokenNameMap = [

    ];

    public function getTokenByName(string $name): TokenInterface
    {
        $originalName = $name;
        if (isset($this->tokenNameMap[$name])) {
            $name = $this->tokenNameMap[$name];
        }
        if (!isset($this->tokenMap[$name])) {
            return new TokenUndefined($originalName);
        } else {
            return new $this->tokenMap[$name]($originalName);
        }
    }
}